// Copyright (c) 2016-2018 LG Electronics, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// SPDX-License-Identifier: Apache-2.0

#ifndef SERVICE_LS2_LS2MESSAGECONTAINER_H_
#define SERVICE_LS2_LS2MESSAGECONTAINER_H_

#include <iostream>
#include <vector>
#include <pbnjson.hpp>

#include "../AbstractBusFactory.h"
#include "util/ObjectCounter.hpp"

using namespace std;
using namespace pbnjson;

class LS2MessageContainer : public IMessages, public ObjectCounter<LS2MessageContainer> {
public:
    LS2MessageContainer();
    virtual ~LS2MessageContainer();

    // IMessages
    virtual bool pushMessage(shared_ptr<IMessage> message);
    virtual bool each(IMessagesListener &listener, JsonDB &newDB, JsonDB &oldDB);

    // Local Method
    void setKey(string key);

private:
    string m_key;

};

#endif /* SERVICE_LS2_LS2MESSAGECONTAINER_H_ */
